<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="公司名" prop="companyId">
        <el-select filterable style="width: 220px" v-model="queryParams.companyId" placeholder="请选择公司名" clearable size="small">
          <el-option
            v-for="item in companys"
            :key="item.companyId"
            :label="item.companyName"
            :value="item.companyId"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="课程" prop="courseId">
        <el-select filterable  v-model="queryParams.courseId" placeholder="请选择课程"  clearable size="small" @change="courseChange(queryParams.courseId)">
          <el-option
            v-for="dict in courseLists"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="小节" prop="videoId">
        <el-select filterable  v-model="queryParams.videoId" placeholder="请选择小节"  clearable size="small">
          <el-option
            v-for="dict in videoList"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker v-model="createTime" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" @change="change"></el-date-picker>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-table border v-loading="loading" :data="courseWatchLogList" show-summary>
      <el-table-column label="公司名称" align="center" prop="companyName" />
      <el-table-column label="发课时间" align="center" prop="createTime"/>
      <el-table-column label="待看课" align="center" prop="type3" />
      <el-table-column label="看课中" align="center" prop="type1" />
      <el-table-column label="已完课" align="center" prop="type2" />
      <el-table-column label="看课中断" align="center" prop="type4" />
    </el-table>
  </div>
</template>

<script>
import {
  listCourseWatchLog,
  getCourseWatchLog,
  delCourseWatchLog,
  addCourseWatchLog,
  updateCourseWatchLog,
  exportCourseWatchLog,
  statisticsList,
  statisticsListByCompany
} from '@/api/course/qw/courseWatchLog'
import { courseList,videoList } from '@/api/course/courseRedPacketLog'
import {getCompanyList} from "@/api/company/company";
export default {
  name: "CourseWatchLog",
  data() {
    return {
      companys:[],
      activeName:"00",
      createTime:null,
      courseLists:[],
      videoList:[],
      logTypeOptions:[],
      // 遮罩层
      loading: false,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 短链课程看课记录表格数据
      courseWatchLogList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userId: null,
        nickName: null,
        videoId: null,
        logType: null,
        qwExternalContactId: null,
        duration: null,
        qwUserId: null,
        companyUserId: null,
        companyId: null,
        courseId: null,
        sTime:null,
        eTime:null,
        scheduleStartTime: null,
        scheduleEndTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      scheduleTime: null,
    };
  },
  created() {
    getCompanyList().then(response => {
      this.companys = response.data;
      if(this.companys!=null&&this.companys.length>0){
        this.companyId=this.companys[0].companyId;
        this.getTreeselect();
      }
    });
    courseList().then(response => {
      this.courseLists = response.list;
    });
    this.getList();
    this.getDicts("sys_course_watch_log_type").then(response => {
      this.logTypeOptions = response.data;
    });
  },
  methods: {
    courseChange(row){
      this.queryParams.videoId=null;
      if(row === ''){
        this.videoList=[];
        return
      }
      videoList(row).then(response => {
        this.videoList=response.list
      });
    },
    change() {
      if (this.createTime != null) {
        this.queryParams.sTime = this.createTime[0];
        this.queryParams.eTime = this.createTime[1];
      } else {
        this.queryParams.sTime = null;
        this.queryParams.eTime = null;
      }
    },
    handleClickX(tab,event){
      this.activeName=tab.name;
      if(tab.name=="00"){
        this.queryParams.logType=null;
      }else{
        this.queryParams.logType=tab.name;
      }
      this.getList()
    },
    /** 查询短链课程看课记录列表 */
    getList() {
      this.loading = true;
      statisticsListByCompany(this.queryParams).then(response => {
        this.courseWatchLogList = response.rows;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        logId: null,
        userId: null,
        videoId: null,
        logType: null,
        createTime: null,
        updateTime: null,
        qwExternalContactId: null,
        duration: null,
        qwUserId: null,
        companyUserId: null,
        companyId: null,
        courseId: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.createTime = null;
      this.scheduleTime = null;
      this.queryParams.sTime = null;
      this.queryParams.eTime = null;
      this.queryParams.scheduleStartTime = null;
      this.queryParams.scheduleEndTime = null;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.logId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加短链课程看课记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const logId = row.logId || this.ids
      getCourseWatchLog(logId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改短链课程看课记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.logId != null) {
            updateCourseWatchLog(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCourseWatchLog(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const logIds = row.logId || this.ids;
      this.$confirm('是否确认删除短链课程看课记录编号为"' + logIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delCourseWatchLog(logIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有短链课程看课记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportCourseWatchLog(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    handleScheduleTimeChange(val) {
      if (val) {
        this.queryParams.scheduleStartTime = val[0];
        this.queryParams.scheduleEndTime = val[1];
      } else {
        this.queryParams.scheduleStartTime = null;
        this.queryParams.scheduleEndTime = null;
      }
    },
  }
};
</script>
